<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">

<head>
<meta http-equiv="Content-type" content="text/html;charset=UTF-8" />
<title>Freghar's Gitlog - The index</title>
</head>


<body>

<h1>The index</h1>
<p>Wheeeeeeee!<br />
Today, I'm finally gonna show you some cool stuff, which some other SCMs have as well, but I really doubt some of them has the power to modify even those ways to handle things.<br />
Let me show you the index, which is a little freaky thing. It's often called "the staging area" or just "cache", you can find many tutorials on this, so I'll leave only a short paragraph on it's indented usage.</p>
<p>Okay, no boring theory, let's get on it!</p>
<hr />
<br />

<h2>The classic usage</h2>
<p>Well the thing why index exists can be guessed by the way people refer to it - "the staging area".<br />
Think of it as of some sort of "virtual tree", some layer between the object database and your working tree (filesystem).</p>

<p>When you are about to commit, only things in the index gets commited. This is the basic idea.</p>

<p>Imagine a situation where you write something one day, forget to commit it and go sleep. In the morning, after receiving some important bug report via email, you start working on something completely different and when you finish it, you eventually imagine that you still have all those dirty changes from yesterday's unfinished feature.<br />
There's a solution for you - the index. Everytime you commit something, you have to git-add it to the index before. Most people just use "git commit -a", which simply adds everything.<br />
Now you want to add only files README, src/game/Level1.cpp, src/game/Level1.h and everything in win/ (since your critical bugfix wasn't related to the win/ directory, so you can add all changes made there):</p>
<pre>
git add README src/game/Level1.* win/
</pre>
<p>That's it. Now you can see in "git status" the actual status - what's ready for commit (staged), what is "changed but not updated" (unstaged) and what's completely untracked (unstaged as well). The basic difference between the second and third state is existence in the repository. "changed but not updated" means that the file already exists, "untracked" is a completely new file.<br />
Now make a commit:</p>
<pre>
git commit
</pre>
<p>Notice there's no "-a" (you already know why..). In your working tree are now only changes related to the bugfix, so you can</p>
<pre>
git add .
git commit
</pre>
<p>all of them (which is the same as "git commit -a").</p>
<br />

<h2>Going more cool</h2>
<p>The actual thing that makes it so "cool" is the fact, that you can add even separate hunks in one file!<br />
So when the bugfix changes something in src/game/Level1.h for example, you can add only the non-critical feature part(s) of changes in the file.</p>

<p>This can be done in the git-gui by right-click on the hunk in text and "add this hunk". The file then appear in both staged and unstaged subwindows, just like in "git status".<br />
The other (classic) way around this is using the console command "git add" with an additional "-i" ("--interactive") argument:</p>
<pre>
$ git add -i
           staged     unstaged path
  1:    unchanged        +2/-0 NEWS
  2:    unchanged        +3/-5 README

*** Commands ***
  1: [s]tatus     2: [u]pdate     3: [r]evert     4: [a]dd untracked
  5: [p]atch      6: [d]iff       7: [q]uit       8: [h]elp
<span><font color="blue">What now&gt;</font></span> <b>5</b>
           staged     unstaged path
  1:    unchanged        +2/-0 [N]EWS
  2:    unchanged        +3/-5 [R]EADME
<span><font color="blue">Patch update&gt;&gt;</font></span> <b>1</b>
           staged     unstaged path
* 1:    unchanged        +2/-0 [N]EWS
  2:    unchanged        +3/-5 [R]EADME
<span><font color="blue">Patch update&gt;&gt;</font></span> <b>2</b>
           staged     unstaged path
* 1:    unchanged        +2/-0 [N]EWS
* 2:    unchanged        +3/-5 [R]EADME
<span><font color="blue">Patch update&gt;&gt;</font></span>
<b>diff --git a/NEWS b/NEWS
index 0cac6a6..d63eafc 100644
--- a/NEWS
+++ b/NEWS</b>
<span><font color="purple">@@ -13,6 +13,8 @@ http://getmangos.com/community/</font></span>
 Please submit bug reports at:
 http://mangos.lighthouseapp.com/

<span><font color="lime">+-- nothing new --
+</font></span>
 Version 0.12
  * Under discussion.
  * Upgrade to client version 2.4.3 (build 8606).
<span><font color="royalblue">Stage this hunk [y/n/a/d/?]?</font></span> <b>y</b>

<b>diff --git a/README b/README
index 8a1bb4e..84b19b2 100644
--- a/README
+++ b/README</b>
<span><font color="purple">@@ -1,7 +1,3 @@</font></span>
<span><font color="red">-= MaNGOS -- README =
-
-Copyright (C) 2005-2008 MaNGOS project &lt;http://getmangos.com/&gt;
-</font></span>
   MaNGOS is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
<span><font color="royalblue">Stage this hunk [y/n/a/d/j/J/?]?</font></span> <b>n</b>
<span><font color="purple">@@ -16,6 +12,8 @@ Copyright (C) 2005-2008 MaNGOS project &lt;http://getmangos.com/&gt;</font></span>
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

<span><font color="lime">+blah blah
+</font></span>
   In addition, as a special exception, the MaNGOS project
   gives permission to link the code of its release of MaNGOS with the
   OpenSSL project's "OpenSSL" library (or with modified versions of it
<span><font color="royalblue">Stage this hunk [y/n/a/d/K/j/J/?]?</font></span> <b>y</b>
<span><font color="purple">@@ -54,4 +52,4 @@ In case you have checked out MaNGOS from the GIT repository, please run</font></span>

 $ autoreconf --install --force

<span><font color="red">-prior to building, as you may otherwise not be able to run a build.</font></span>
<span><font color="lime">+prior to compiling, as you may otherwise not be able to run a build.</font></span>
<span><font color="royalblue">Stage this hunk [y/n/a/d/K/?]?</font></span> <b>y</b>

*** Commands ***
  1: [s]tatus     2: [u]pdate     3: [r]evert     4: [a]dd untracked
  5: [p]atch      6: [d]iff       7: [q]uit       8: [h]elp
<span><font color="blue">What now&gt;</font></span>
</pre>
<p>In the first step, choose "5" for "patch", the second step is just to mark which files you want to search (so you won't have go through 2000 files if you have them unstaged - just hit enter when you're done with file selection) and the final third step is "marking" hunks to stage.<br />
You might note more commands than just "y/n", those are</p>
<pre>
               y - stage this hunk
               n - do not stage this hunk
               a - stage this and all the remaining hunks in the file
               d - do not stage this hunk nor any of the remaining hunks in the file
               j - leave this hunk undecided, see next undecided hunk
               J - leave this hunk undecided, see next hunk
               k - leave this hunk undecided, see previous undecided hunk
               K - leave this hunk undecided, see previous hunk
               s - split the current hunk into smaller hunks
               ? - print help
           After deciding the fate for all hunks, if there is any hunk that was chosen,
           the index is updated with the selected hunks.
</pre>
<p>.. which reminds me to remind you - <u>read git add's manual page for more information about interactive mode</u>.</p>

<p>After that, "git status" looks like this:</p>
<pre>
$ git status
# Not currently on any branch.
# Changes to be committed:
#   (use "git reset HEAD &lt;file&gt;..." to unstage)
#
#       <span><font color="lime">modified:   NEWS</font></span>
#       <span><font color="lime">modified:   README</font></span>
#
# Changed but not updated:
#   (use "git add &lt;file&gt;..." to update what will be committed)
#
#       <span><font color="red">modified:   README</font></span>
#
</pre>
<p>(I left that one hunk in README as unstaged, that's why the file is both in staged and unstaged "parts".)</p>

<p>I hope you understand this so far, try google on "git index" for more info if not.</p>
<br />

<h2>Going deeper ...</h2>
<p>Damn, that took longer than I expected, so let's move to something I wanted to write about in the first place.</p>

<h3>WTF is git checkout</h3>
<p>Using it every day, still don't get how it's working? "git checkout", as many other high level commands ("porcelains"), calls lower level tools ("plumbing") to do the dirty job.</p>
<p>This command has 2 modes:</p>
<ol>
<li>it serves as a shortcut for creating branch and checkouting it when used with the "-b" parameter (ie. "git branch" + "git checkout")</li>
<li>the main purpose of this high level tool is to reset the index to some specified state and call git-checkout-index plubming command (see it's manpage) to copy index's "contents" into your filesystem.</li>
</ol>
<p>I'll explain only the second part, refer to manpage of git-branch for the first one.</p>

<p>As you might get from this list, index serves as some kind of "cache" between the object database and your filesystem (= working tree). When you checkout some commit (or branch), the state of files is "copied" to the index, and then mirrored to your tree. So when you modify something there and do a "git diff", the diff shows what you've modified (ie. it just <u>diffs your working tree and the index</u>).</p>

<p>So what's going to happen when you issue command "git checkout abcdef5" ? In simple steps:</p>
<ol>
<li>it finds a tree object related to that commit object (???object??? -- see first chapter - links - "git for computer scientists")</li>
<li>it "copies" all the blob objects in that tree to your index</li>
<li>it mirrors your index to the filesystem (= working tree)</li>
</ol>
<p>Here comes the thing why I call index the "virtual tree". When git-checkout reaches the 2nd part and all those blobs have about .. 600MB, the index is still ~1MB. Why? Because it's <u>virtual</u> tree, it does not contain data, just references and metadata, but you don't really need to care about that right now.</p>

<p>What about branches? Since branch is nothing more than a "pointer" to some commit SHA, it's almost the same.<br />
So "git checkout origin/master":</p>
<ol>
<li>looks up .git/refs/remotes/origin/master for a commit hash</li>
<li>(does all the stuff specified before)</li>
</ol>
<p>Pretty neat, isn't it?</p>

<h2>... and deeper ... and deeper ...</h2>
<p>Now I'm going to show you something that probably no other SCM can do, just because Git is like Macgyver, it doesn't tells you how you should use things, it just allows you to use them as you like.<br />
Therefore, I'm going to use the index's caching ability to virtually store some older data and then checkout them to my filesystem, without moving out of my "master" branch.</p>
<p>"git reset" has, as the "git checkout", two modes:</p>
<ol>
<li>it can move the current HEAD and optionally reset the index, working tree or both</li>
<li>it can reset some file(s) to a specified commit and put them to the index, without touching your HEAD or working tree</li>
</ol>
<p>Most of you probably came across the git-reset already..<br />
(manpage):</p>
<pre>
       --mixed
           Resets the index but not the working tree (i.e., the changed files
           are preserved but not marked for commit) and reports what has not
           been updated. This is the default action.

       --soft
           Does not touch the index file nor the working tree at all, but
           requires them to be in a good order. This leaves all your changed
           files "Changes to be committed", as git-status(1) would put it.

       --hard
           Matches the working tree and index to that of the tree being
           switched to. Any changes to tracked files in the working tree since
           &lt;commit&gt; are lost.
</pre>
<p>This is, however, only the first mode, the second can be used like</p>
<pre>
git reset abdcef4 -- file1.c file3.h
</pre>
<p>where everything after "--" means list of files (this is not git-specific, it's common for 99% of cmdline programs).<br />
This means that we can reset specific files to the state as they were .. 5 commits ago and put them in the index, so we can "git diff" the actual working tree (which is correctly set to the current HEAD as only index has changed) and the index. The diff will display changes made by those commits, but in reverse - those changes aren't in the working tree, but are in the index, so it looks like we reverted them.</p>

<p>To move out of theory and start with some examples, let's checkout 06ed6af86c:</p>
<pre>
$ git checkout 06ed6af86c
HEAD is now at 06ed6af... Fixed: restore RA login work.
</pre>
<p>In this example, I'm going to reset index only 2 commits back, it's enough for the example itself and those commits made only small changes so we can actually see them in one page.</p>

<p>But let's assume I don't know which files were changed, I'm gonna reset everything using a smart path specification:</p>
<pre>
$ git reset HEAD~2 -- .
src/game/SpellMgr.cpp: needs update
src/mangosd/RASocket.cpp: needs update
</pre>
<p>(in root of the source dir)<br />
So I'm now two commits back. One of them changed SpellMgr.cpp, the other one RASocket.cpp. In this state, my HEAD (as well as working tree) is still at 06ed6af, only the index is 2 commits back. We can actually see that in the "git status":</p>
<pre>
$ git status
# Not currently on any branch.
# Changes to be committed:
#   (use "git reset HEAD &lt;file&gt;..." to unstage)
#
#       <span><font color="lime">modified:   src/game/SpellMgr.cpp</font></span>
#       <span><font color="lime">modified:   src/mangosd/RASocket.cpp</font></span>
#
# Changed but not updated:
#   (use "git add &lt;file&gt;..." to update what will be committed)
#
#       <span><font color="red">modified:   src/game/SpellMgr.cpp</font></span>
#       <span><font color="red">modified:   src/mangosd/RASocket.cpp</font></span>
#
</pre>
<p>It might look as the git has gone crazy, but this output is quite logical; when you modify local files, you can view the changes using "git diff" and "git status" will show them as unstaged. When you add those files into index, "git status" shows them as staged and "git diff" doesn't show anything. This is because of the default behavior of "git diff" - to display differencies between working tree and the index. When you stage all of those changes, there just aren't any diffs.</p>
<p>So the "staged" part actually refer to changes made by the commit (which is 2 commits behind our HEAD), while the "unstaged" part refers to actual changes that our HEAD introduced, but the index doesn't know they're already commited. So the "git diff" output looks like</p>
<pre>
$ git diff
<b>diff --git a/src/game/SpellMgr.cpp b/src/game/SpellMgr.cpp
index ef84b1d..d89c6e3 100644
--- a/src/game/SpellMgr.cpp
+++ b/src/game/SpellMgr.cpp</b>
<span><font color="purple">@@ -2059,7 +2059,7 @@ bool IsSpellAllowedInLocation(SpellEntry const *spellInfo,uint32 map_id,uint32 z</font></span>
                 // in the Blade's Edge Mountains Plateaus and Gruul's Lair.
                 return zone_id ==3522 || map_id==565;
             }
<span><font color="red">-            if(mask &amp; ELIXIR_UNSTABLE_MASK)</font></span>
<span><font color="lime">+            if(mask &amp; ELIXIR_SHATTRATH_MASK)</font></span>
             {
                 // in Tempest Keep, Serpentshrine Cavern, Caverns of Time: Mount Hyjal, Black Temple
                 // TODO: and the Sunwell Plateau
<b>diff --git a/src/mangosd/RASocket.cpp b/src/mangosd/RASocket.cpp
index 71daf17..3503659 100644
--- a/src/mangosd/RASocket.cpp
+++ b/src/mangosd/RASocket.cpp</b>
<span><font color="purple">@@ -194,7 +194,10 @@ void RASocket::OnRead()</font></span>
                     loginDatabase.escape_string(login);
                     loginDatabase.escape_string(pw);

<span><font color="red">-                    QueryResult *check = loginDatabase.PQuery("SELECT 1 FROM account WHERE username = '%s' AND sha_pass_hash=SHA1(CONCAT(username,':','%s'))", login.c_str(), pw.c_str());</font></span>
<span><font color="lime">+                    QueryResult *check = loginDatabase.PQuery(
+                        "SELECT 1 FROM account WHERE username = '%s' AND sha_pass_hash=SHA1(CONCAT(username,':','%s'))",
+                        login.c_str(), login.c_str(), pw.c_str());
+</font></span>
                     if(check)
                     {
                         delete check;

</pre>
<p>which is the exact opposite of what those 2 commits made, you should now understand why.</p>

<p>To copy index's contents to the working tree, simply</p>
<pre>
git checkout -f src/game/SpellMgr.cpp
git checkout -f src/mangosd/RASocket.cpp
</pre>
<p>(remember? it calls git-checkout-index, which is for that purpose)</p>

<p>.. or if you want to copy files from your working tree TO the index, simply add them:</p>
<pre>
git add src/game/SpellMgr.cpp
git add src/mangosd/RASocket.cpp
</pre>

<p>You might as well use a small trick to actually checkout a file into both index and working tree at the same time:</p>
<pre>
git checkout HEAD -- src/game/SpellMgr.cpp
git checkout HEAD -- src/mangosd/RASocket.cpp
</pre>

<p>As you can see, it's possible to use index even this way, just to explore it's powers.</p>
<hr />
<br />

<p>I hope you've learned something useful from this article, any comments are, as usual, welcomed.</p>

<p>Freghar</p>

</body>


</html>
